unit Standard;

interface

const MAX = 25;
type TGrid = array[0..MAX-1, 0..MAX-1] of Char;
var  Grid: TGrid;
const SIZE : Integer = 9;
const Grid345 : Integer = 3;
const allowedSymbols: String ='';
const MaxValid: Integer = 0;
const LEER = '.';

procedure PrintGrid(var Grid: TGrid; ShowValid, Wait: Boolean);
function HasValidInGrid(var Grid: TGrid): Integer;

implementation

uses Crt;

function HasValidInGrid(var Grid: TGrid): Integer;
var
   Row, Col, Valid: Integer;
   Symbol: Char;
begin
   Valid := 0;
   for Row := 0 to SIZE-1 do begin
      for Col := 0 to SIZE-1 do begin
         Symbol := Grid[Row, Col];
         if Symbol <> LEER then
            Inc(Valid);
      end;
   end;
   HasValidInGrid := Valid;
end;

procedure PrintGrid(var Grid: TGrid; ShowValid, Wait: Boolean);
var
   valid, i, j: Integer;
begin
   for i := 0 to SIZE-1 do begin
      for j := 0 to SIZE-1 do begin
         Write(Grid[i, j]:2, ' ');
      end;
      WriteLn;
   end;

   if ShowValid then begin
      Valid := HasValidInGrid(Grid);
      WriteLn('Solved cells: ', Valid, '/', SIZE * SIZE);
   end;
   if Wait then begin
      WriteLn('Press Enter to continue...');
      ReadLn;
   end;
end;

end.

